/* Copyright (C) 2011, 2012, 2013 by Bundesanstalt für Gewässerkunde
 * Software engineering by Intevation GmbH
 *
 * This file is Free Software under the GNU AGPL (>=v3)
 * and comes with ABSOLUTELY NO WARRANTY! Check out the
 * documentation coming with Dive4Elements River for details.
 */

package org.dive4elements.river.importer;

import java.util.List;

import org.apache.log4j.Logger;
import org.dive4elements.river.model.BedHeightType;
import org.hibernate.Query;
import org.hibernate.Session;


public class ImportBedHeightType {

    private static final Logger log =
            Logger.getLogger(ImportBedHeightType.class);

    protected String name;

    protected BedHeightType peer;

    public ImportBedHeightType(final BedHeightType peer)  {
        this.peer = peer;
        this.name = peer.getName();
    }


    public ImportBedHeightType(final String name) {
        this.name        = name;
    }


    public void storeDependencies() {
        getPeer();
    }


    public BedHeightType getPeer() {
        if (this.peer != null)
            return this.peer;
        final Session session = ImporterSession.getInstance().getDatabaseSession();
        final Query query = session.createQuery("FROM BedHeightType WHERE (trim(name)=:name) AND (trim(description)=:description)");
        query.setParameter("name", this.name);
        final List<BedHeightType> types = query.list();
        if (types.isEmpty()) {
            this.peer = new BedHeightType(this.name);
            session.save(this.peer);
        } else {
            this.peer = types.get(0);
        }
        return this.peer;
    }
}
// vim:set ts=4 sw=4 si et sta sts=4 fenc=utf8 :
